﻿  // @file itf2_image.h
  // @brief Image data structures and functions.
  // @author Mamoru Kaminaga
  // @date 2017-12-14 10:34:25
  // Copyright 2017 Mamoru Kaminaga
  // Released under the MIT license
  // http://opensource.org/licenses/mit-license.php
#ifndef ITF2_IMAGE_H_
#define ITF2_IMAGE_H_

#include <wchar.h>
#include <memory>

class ITF2Image {
 public:
  enum TEXTFORMAT {
    TEXTFORMAT_DEC,
    TEXTFORMAT_HEX,
    TEXTFORMAT_CMD,  // Write only
  };

 public:
  ITF2Image();
  ~ITF2Image();
  bool ReadPNGFile(const wchar_t* file_name);
  bool ReadTextFile(const wchar_t* file_name, TEXTFORMAT format);
  bool WritePNGFile(const wchar_t* file_name);
  bool WriteTextFile(const wchar_t* file_name, TEXTFORMAT format);
  bool RemoveNonUsedColors();
  bool ShowImageDataSize();
  bool ShowVerboseInfo();
  int GetImageDataSize();

 private:
  struct Pimpl;
  std::unique_ptr<Pimpl> pimpl_;
};

#endif  // ITF2_IMAGE_H_
