# makefile_win32.mk
# date 2017-09-05
# Copyright 2017 Mamoru Kaminaga
# Released under the MIT license
# http://opensource.org/licenses/mit-license.php
!IF !DEFINED(DEBUG)
!	ERROR "Error...YOU MUST DEFINE DEBUG=1/0"
!ENDIF

CC = C:\"Program Files (x86)"\"Microsoft Visual Studio\2017"\Community\VC\Tools\MSVC\14.10.25017\bin\HostX86\x86\cl.exe
LINK = C:\"Program Files (x86)"\"Microsoft Visual Studio\2017"\Community\VC\Tools\MSVC\14.10.25017\bin\HostX86\x86\link.exe
TARGET = itf2img.exe
PDB = itf2img.pdb
MAP = itf2img.map
RES =

!IF $(DEBUG) == 1
OBJDIR = build\\windows\\debug
CPPFLAGS = /nologo /W4 /Zi /O2 /MT /D"UNICODE" /D"_UNICODE" /D"DEBUG" /TP\
	/EHsc /Fd"$(OBJDIR)/" /D"NOMINMAX" /D"WIN32" /D"DEBUG"
LFLAGS = $(LIBS) /NOLOGO /SUBSYSTEM:CONSOLE /PDB:"$(PDB)" /MAP:"$(MAP)"\
	/DEBUG
!ELSE
OBJDIR = build\\windows\\release
CPPFLAGS = /nologo /W4 /Zi /O2 /MT /D"UNICODE" /D"_UNICODE"\
					 /EHsc /Fd"$(OBJDIR)/" /D"NOMINMAX" /D"WIN32"
LFLAGS = $(LIBS) /NOLOGO /SUBSYSTEM:CONSOLE /PDB:"$(PDB)" /MAP:"$(MAP)"
!ENDIF

SRC = main.cc itf2_image.cc util.cc
OBJ = $(OBJDIR)/main.obj $(OBJDIR)/itf2_image.obj $(OBJDIR)/util.obj
LIBS = "kernel32.lib" "user32.lib" "gdi32.lib" "winspool.lib" "comdlg32.lib" "advapi32.lib" "shell32.lib" "ole32.lib" "oleaut32.lib" "uuid.lib" "odbc32.lib" "odbccp32.lib" "libpng.lib" "zlib.lib"

ALL: $(TARGET)

$(TARGET): $(OBJ) $(RES)
	$(LINK) $(LFLAGS) /OUT:$(TARGET) $(OBJ) $(RES)

.cc{$(OBJDIR)}.obj:
	@[ -d $(OBJDIR) ] || mkdir $(OBJDIR)
	$(CC) $(CPPFLAGS) /Fo"$(OBJDIR)\\" /c $<
