﻿  // @file util.h
  // @brief Useful common functions
  // @author Mamoru Kaminaga
  // @date 2017-12-15 11:38:55
  // Copyright 2017 Mamoru Kaminaga
  // Released under the MIT license
  // http://opensource.org/licenses/mit-license.php
#ifndef UTIL_H_
#define UTIL_H_

#include <stdarg.h>
#include <stdio.h>
#include <time.h>
#include <wchar.h>
#include <string>

#define UTIL_MAXSTRLEN   (1024)

std::basic_string<char> GetMBS(const wchar_t* format, ...);
std::basic_string<wchar_t> GetWCS(const char* format, ...);

  // File IO wrapper.
enum RWMODE {
  RWMODE_DEC,
  RWMODE_HEX,
  RWMODE_CMD,  // Write mode only.
};
FILE* Fopen(const wchar_t* file_name, const wchar_t* mode);
int ReadByte(FILE* fp, RWMODE mode);
void WriteByte(FILE* fp, int value, RWMODE mode);

  // Time wrapper.
void GetLocalTime(struct tm* local_time);

#endif  // UTIL_H_
